--- WARNING: THIS IS AN AUTO-GENERATED FILE, DO NOT EDIT. PLEASE MODIFY THE ORIGINAL SOURCE IN THE https://github.com/istio/istio REPO source_repo: https://github.com/istio/istio title: sidecar-injector description: Kubernetes webhook for automatic Istio sidecar injection. generator: pkg-collateral-docs number_of_entries: 4 ---

Kubernetes webhook for automatic Istio sidecar injection.

    sidecar-injector [flags]

Flags | Description
--- | ---
`--caCertFile <string>` | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/root-cert.pem`)
`--healthCheckFile <string>` | File that should be periodically updated if health checking is enabled (default ``)
`--healthCheckInterval <duration>` | Configure how frequently the health check file specified by --healthCheckFile should be updated (default `0s`)
`--injectConfig <string>` | File containing the Istio sidecar injection configuration and template (default `/etc/istio/inject/config`)
`--injectValues <string>` | File containing the Istio sidecar injection values, in yaml format (default `/etc/istio/inject/values`)
`--kubeconfig <string>` | Specifies path to kubeconfig file. This must be specified when not running inside a Kubernetes pod. (default ``)
`--log_as_json` | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` | Comma-separated list of scopes for which to include caller information, scopes can be any of [all, default, model, rbac] (default ``)
`--log_output_level <string>` | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--meshConfig <string>` | File containing the Istio mesh configuration (default `/etc/istio/config/mesh`)
`--port <int>` | Webhook port (default `443`)
`--tlsCertFile <string>` | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/cert-chain.pem`)
`--tlsKeyFile <string>` | File containing the x509 private key matching --tlsCertFile. (default `/etc/istio/certs/key.pem`)
`--webhookConfigName <string>` | Name of the mutatingwebhookconfiguration resource in Kubernetes. (default `istio-sidecar-injector`)
`--webhookName <string>` | Name of the webhook entry in the webhook config. (default `sidecar-injector.istio.io`)

## sidecar-injector probe

Check the liveness or readiness of a locally-running server

    sidecar-injector probe [flags]

Flags | Description
--- | ---
`--caCertFile <string>` | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/root-cert.pem`)
`--healthCheckFile <string>` | File that should be periodically updated if health checking is enabled (default ``)
`--healthCheckInterval <duration>` | Configure how frequently the health check file specified by --healthCheckFile should be updated (default `0s`)
`--injectConfig <string>` | File containing the Istio sidecar injection configuration and template (default `/etc/istio/inject/config`)
`--injectValues <string>` | File containing the Istio sidecar injection values, in yaml format (default `/etc/istio/inject/values`)
`--interval <duration>` | Duration used for checking the target file's last modified time. (default `0s`)
`--kubeconfig <string>` | Specifies path to kubeconfig file. This must be specified when not running inside a Kubernetes pod. (default ``)
`--log_as_json` | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` | Comma-separated list of scopes for which to include caller information, scopes can be any of [all, default, model, rbac] (default ``)
`--log_output_level <string>` | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--meshConfig <string>` | File containing the Istio mesh configuration (default `/etc/istio/config/mesh`)
`--port <int>` | Webhook port (default `443`)
`--probe-path <string>` | Path of the file for checking the availability. (default ``)
`--tlsCertFile <string>` | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/cert-chain.pem`)
`--tlsKeyFile <string>` | File containing the x509 private key matching --tlsCertFile. (default `/etc/istio/certs/key.pem`)
`--webhookConfigName <string>` | Name of the mutatingwebhookconfiguration resource in Kubernetes. (default `istio-sidecar-injector`)
`--webhookName <string>` | Name of the webhook entry in the webhook config. (default `sidecar-injector.istio.io`)

## sidecar-injector version

Prints out build version information

    sidecar-injector version [flags]

Flags | Shorthand | Description
--- | --- | ---
`--caCertFile <string>` |  | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/root-cert.pem`)
`--healthCheckFile <string>` |  | File that should be periodically updated if health checking is enabled (default ``)
`--healthCheckInterval <duration>` |  | Configure how frequently the health check file specified by --healthCheckFile should be updated (default `0s`)
`--injectConfig <string>` |  | File containing the Istio sidecar injection configuration and template (default `/etc/istio/inject/config`)
`--injectValues <string>` |  | File containing the Istio sidecar injection values, in yaml format (default `/etc/istio/inject/values`)
`--kubeconfig <string>` |  | Specifies path to kubeconfig file. This must be specified when not running inside a Kubernetes pod. (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [all, default, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--meshConfig <string>` |  | File containing the Istio mesh configuration (default `/etc/istio/config/mesh`)
`--output <string>` | `-o` | One of 'yaml' or 'json'. (default ``)
`--port <int>` |  | Webhook port (default `443`)
`--short` | `-s` | Use --short=false to generate full version information
`--tlsCertFile <string>` |  | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/cert-chain.pem`)
`--tlsKeyFile <string>` |  | File containing the x509 private key matching --tlsCertFile. (default `/etc/istio/certs/key.pem`)
`--webhookConfigName <string>` |  | Name of the mutatingwebhookconfiguration resource in Kubernetes. (default `istio-sidecar-injector`)
`--webhookName <string>` |  | Name of the webhook entry in the webhook config. (default `sidecar-injector.istio.io`)

## Exported metrics

Metric Name | Type | Description
--- | --- | ---
`endpoint_no_pod` | `LastValue` | Endpoints without an associated pod.
`pilot_conflict_inbound_listener` | `LastValue` | Number of conflicting inbound listeners.
`pilot_conflict_outbound_listener_http_over_current_tcp` | `LastValue` | Number of conflicting wildcard http listeners with current wildcard tcp listener.
`pilot_conflict_outbound_listener_tcp_over_current_http` | `LastValue` | Number of conflicting wildcard tcp listeners with current wildcard http listener.
`pilot_conflict_outbound_listener_tcp_over_current_tcp` | `LastValue` | Number of conflicting tcp listeners with current tcp listener.
`pilot_destrule_subsets` | `LastValue` | Duplicate subsets across destination rules for same host
`pilot_duplicate_envoy_clusters` | `LastValue` | Duplicate envoy clusters caused by service entries with same hostname
`pilot_eds_no_instances` | `LastValue` | Number of clusters without instances.
`pilot_endpoint_not_ready` | `LastValue` | Endpoint found in unready state.
`pilot_jwks_resolver_network_fetch_fail_total` | `Sum` | Total number of failed network fetch by pilot jwks resolver
`pilot_jwks_resolver_network_fetch_success_total` | `Sum` | Total number of successfully network fetch by pilot jwks resolver
`pilot_no_ip` | `LastValue` | Pods not found in the endpoint table, possibly invalid.
`pilot_total_rejected_configs` | `Sum` | Total number of configs that Pilot had to reject or ignore.
`pilot_virt_services` | `LastValue` | Total virtual services known to pilot.
`pilot_vservice_dup_domain` | `LastValue` | Virtual services with dup domains.